package Klaseak;

import java.awt.Desktop;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import java.io.File;
import java.io.IOException;
import java.sql.Date;
import java.util.ArrayList;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JCheckBox;

import jxl.Workbook;
import jxl.format.Colour;
import jxl.write.DateFormat;
import jxl.write.DateTime;
import jxl.write.Label;
import jxl.write.WritableCellFormat;
import jxl.write.WritableFont;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;
import twitter4j.TwitterException;



public class BabeskopiakExportatu extends JFrame {
	
	
	private JPanel contentPane;
	private JTextField artxiboIzena;
	private JTextField artxiboaGordetzekoPatha;
	private JCheckBox denak, jmz,tweetak,faboritoak,mentzioak,bmz,rt;
	private ExportatuKontsulta kontsulta = new ExportatuKontsulta();
	private HizkuntzaAldaketa hA= new HizkuntzaAldaketa();
	String helbidea;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BabeskopiakExportatu frame = new BabeskopiakExportatu();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public BabeskopiakExportatu() {
		this.setTitle(hA.getValue("exp"));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 330);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		botoiakSortu();
		labelakSortu();
		textFieldSortu();		
		botoiakSortu();
		checkBoxakSortu();
	}
	
	public void textFieldSortu(){
		
		artxiboIzena = new JTextField();
		artxiboIzena.setBounds(22, 32, 186, 19);
		contentPane.add(artxiboIzena);
		artxiboIzena.setColumns(10);
		
		artxiboaGordetzekoPatha = new JTextField();
		artxiboaGordetzekoPatha.setBounds(132, 93, 264, 19);
		contentPane.add(artxiboaGordetzekoPatha);
		artxiboaGordetzekoPatha.setColumns(10);
	}
	
	public void botoiakSortu(){
		
		JButton btnIrten = new JButton(hA.getValue("i"));
		btnIrten.setBounds(311, 266, 117, 25);
		contentPane.add(btnIrten);
		
		btnIrten.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				JFrame frame = Aplikazioa.getInstantzia().getMenuNagusia();
				BabeskopiakExportatu.this.dispose();
				frame.setVisible(true);
				
			}
		});
		
		JButton btnExportatu = new JButton(hA.getValue("exp1"));
		btnExportatu.setBounds(182, 266, 117, 25);
		contentPane.add(btnExportatu);
		
		btnExportatu.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				ArrayList<String> exportatzekoMotak=null;
				BabeskopiakExportatu.this.exportatuDatuak(exportatzekoMotak,0,0,"","");
				BabeskopiakExportatu.this.hasieratuDena();
			}
		});
		
		JButton btnExaminar = new JButton(hA.getValue("exam"));
		btnExaminar.setBounds(12, 90, 117, 25);
		contentPane.add(btnExaminar);
		btnExaminar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
				JFileChooser examinar= new JFileChooser();
				examinar.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int erantzuna= examinar.showSaveDialog(BabeskopiakExportatu.this);
				examinar.setVisible(true);
				
				if(erantzuna==JFileChooser.APPROVE_OPTION){
				String patha=examinar.getSelectedFile().getAbsolutePath();
				artxiboaGordetzekoPatha.setText(patha);
				}
				
			}
		});
	}
	
	public void labelakSortu(){
		
		JLabel lblPatha = new JLabel(hA.getValue("pathExp"));
		lblPatha.setBounds(12, 63, 384, 15);
		contentPane.add(lblPatha);
		
		JLabel lblZeinIzenJarriko = new JLabel(hA.getValue("izenExp"));
		lblZeinIzenJarriko.setBounds(12, 12, 384, 15);
		contentPane.add(lblZeinIzenJarriko);
		
		JLabel lblZerExportatuNahi = new JLabel(hA.getValue("zerExp"));
		lblZerExportatuNahi.setBounds(12, 124, 202, 15);
		contentPane.add(lblZerExportatuNahi);
	}
	
	public void checkBoxakSortu(){
		tweetak = new JCheckBox(hA.getValue("t"));
		tweetak.setBounds(12, 165, 202, 23);
		contentPane.add(tweetak);
		
		 rt = new JCheckBox(hA.getValue("rt"));
		 rt.setBounds(12, 138, 202, 23);
		contentPane.add(rt);
		
		faboritoak = new JCheckBox(hA.getValue("f"));
		faboritoak.setBounds(238, 165, 213, 23);
		contentPane.add(faboritoak);
		
		mentzioak = new JCheckBox(hA.getValue("m"));
		mentzioak.setBounds(238, 138, 202, 23);
		contentPane.add(mentzioak);
		
		bmz = new JCheckBox(hA.getValue("imz"));
		bmz.setBounds(12, 194, 222, 23);
		contentPane.add(bmz);
		
		jmz = new JCheckBox(hA.getValue("jmz"));
		jmz.setBounds(238, 192, 203, 23);
		contentPane.add(jmz);
		
		denak = new JCheckBox(hA.getValue("all"));
		denak.setBounds(12, 221, 134, 23);
		contentPane.add(denak);
	}
	
	public void exportatuDatuak(ArrayList<String> exportatzekoMotak, long data1, long data2,String path1, String izen1){
		
		if(exportatzekoMotak==null){
		exportatzekoMotak = arraiaBete();
		}
		if(!(path1.equals(""))){
			artxiboaGordetzekoPatha.setText(path1);
			artxiboIzena.setText(izen1);
		}
		liburuaSortu(exportatzekoMotak, data1, data2);
		
		try {
			Desktop.getDesktop().open(new File(artxiboaGordetzekoPatha.getText()+"/"+artxiboIzena.getText()+".xls"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		}
	
	

	public ArrayList<String> arraiaBete(){
		ArrayList<String> exportatzeko = new  ArrayList<String>();
		if (denak.isSelected()){
			exportatzeko.add("Tweeta");
			exportatzeko.add("Faboritoa");
			exportatzeko.add("Mentzioa");
			exportatzeko.add("RT");
			exportatzeko.add("Jasotako Mezu Zuzena");
			exportatzeko.add("Bidalitako Mezu Zuzena");
			
		}else{
			if (tweetak.isSelected()){
				exportatzeko.add("Tweeta");				
			}
			if(rt.isSelected()){
				exportatzeko.add("RT");
			}
			if(faboritoak.isSelected()){
				exportatzeko.add("Faboritoa");
			}
			if(mentzioak.isSelected()){
				exportatzeko.add("Mentzioa");
			}
			if(jmz.isSelected()){
				exportatzeko.add("Jasotako Mezu Zuzena");
			}
			if(bmz.isSelected()){
				exportatzeko.add("Bidalitako Mezu Zuzena");
			}
		}
		
		
		return exportatzeko;
	}

 	public void liburuaSortu(ArrayList<String> motak,long data1,long data2) {
		
		
		WritableWorkbook liburua = null;
	
		
		try {
				
				liburua = Workbook.createWorkbook(new File(artxiboaGordetzekoPatha.getText()+"/"+artxiboIzena.getText()+".xls"));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		WritableSheet berria;
		
		for(String elem:motak){
						
			berria=liburua.createSheet(elem+"k",0);
			tweetenTituluaEtaDatuakSartu(berria,elem, data1,data2);
		}
		
		WritableSheet informazioa= liburua.createSheet(hA.getValue("iO"),0);
		informazioaSortu(informazioa,motak);
		
		try {
			liburua.write();
			liburua.close();
		} catch (WriteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

 	public void tweetenTituluaEtaDatuakSartu(WritableSheet berria,String mota, long data1, long data2){
 		
 		WritableFont letra= new WritableFont(WritableFont.TIMES,20,WritableFont.BOLD,true);
 		WritableCellFormat tituluHandia= new WritableCellFormat(letra); 
 		
 		
 		WritableFont letra2= new WritableFont(WritableFont.TIMES,16,WritableFont.BOLD,true);
 		WritableCellFormat tituluak= new WritableCellFormat(letra2); 	
 		
 		try {
			berria.setRowView(5,180);
		} catch (RowsExceededException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
 		
 		Label label = new Label(0,0,mota,tituluHandia);
 		Label label2;
 		
 		if(mota.equals("Bidalitako Mezu Zuzenak")){
 			label2= new Label(1,5,hA.getValue("nori"), tituluak);
 		}else{
 			label2=new Label(1,5,hA.getValue("norena"),tituluak);
 		}
 		
		Label label3 = new Label(2,5,hA.getValue("test"),tituluak);
		Label label4=new Label(3,5,hA.getValue("data"),tituluak);
		Label label5= new Label(4,5,hA.getValue("id"),tituluak);
		try {
			berria.addCell(label);
			berria.addCell(label2);
			berria.addCell(label3);
			berria.addCell(label4);
			berria.addCell(label5);
			
		} catch (RowsExceededException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (WriteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		if(mota.equals("Tweeta")||mota.equals("Faboritoa")||mota.equals("Mentzioa")||mota.equals("RT")){
			ArrayList<Lag> arraiDatuak=new ArrayList<Lag>();
			try {
				if( data1==0){
					arraiDatuak=kontsulta.tweetakLortu(Aplikazioa.getInstantzia().getTwitter().getScreenName(),mota,arraiDatuak);
				}else{
					arraiDatuak=kontsulta.tweetakLortu(Aplikazioa.getInstantzia().getTwitter().getScreenName(),mota,arraiDatuak, data1,data2);
				}
				tweetDatuakFitxeroanSartu(arraiDatuak,berria);
				
			} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TwitterException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}else{
			ArrayList<Lag_mezuak>  arraiDatuak =new ArrayList<Lag_mezuak>();
			
			try {
				if (data1==0){
					arraiDatuak=kontsulta.mezuDatuakLortu(Aplikazioa.getInstantzia().getTwitter().getScreenName(),mota,arraiDatuak);
				}else{
				arraiDatuak=kontsulta.mezuDatuakLortu(Aplikazioa.getInstantzia().getTwitter().getScreenName(),mota,arraiDatuak, data1, data2);
				}
				mezuakDatuakFitxeroanSartu(arraiDatuak,berria,mota);
			} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TwitterException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}	
		
		
		
	}
	

	public void setArtxiboaGordetzekoPatha(JTextField artxiboaGordetzekoPatha) {
		this.artxiboaGordetzekoPatha = artxiboaGordetzekoPatha;
	}

	public void tweetDatuakFitxeroanSartu(ArrayList<Lag>arraia,WritableSheet orria){
		
		
		
		WritableFont letra= new WritableFont(WritableFont.TIMES,10,WritableFont.NO_BOLD,true);
 		WritableCellFormat formatoa= new WritableCellFormat(letra); 	
					
 			orria.setColumnView(0,15);
 			orria.setColumnView(1,20);
 			orria.setColumnView(2,120);
 			orria.setColumnView(3,20);
 			orria.setColumnView(4,20);
 		try {
			orria.setRowView(0,500);
			orria.setRowView(5,400);
		} catch (RowsExceededException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
 		DateFormat dataFormatoa= new DateFormat ("yyyy-MM-dd hh:mm:ss");
 		WritableCellFormat formatoaData=new WritableCellFormat(dataFormatoa);
 		
		java.util.Iterator<Lag> it=arraia.iterator();
		Lag tweeta;
		int k=6;
		
		while(it.hasNext()){
			tweeta=it.next();
			Label label1 = new Label(1,k,tweeta.norena,formatoa);
			Label label2= new Label(2,k,tweeta.testua,formatoa);
			DateTime data= new jxl.write.DateTime(3,k,tweeta.data,formatoaData);
			Label label3= new Label(4,k,String.valueOf(tweeta.id),formatoa);
			try {
				orria.addCell(label1);
				orria.addCell(label2);
				orria.addCell(data);
				orria.addCell(label3);
					
			} catch (RowsExceededException e) {
				
				e.printStackTrace();
			} catch (WriteException e) {
				
				e.printStackTrace();
			}
				k++;
		}
			
	}
	
	public void mezuakDatuakFitxeroanSartu(ArrayList<Lag_mezuak> datuak,WritableSheet orria,String mota){

		
		int k=6;
		
		
		
 		WritableFont letra= new WritableFont(WritableFont.TIMES,10,WritableFont.NO_BOLD,true);
 		WritableCellFormat formatoa= new WritableCellFormat(letra); 
 		
 		DateFormat dataFormatoa= new DateFormat ("yyyy-MM-dd hh:mm:ss");
 		WritableCellFormat formatoaData=new WritableCellFormat(dataFormatoa);
 		
		java.util.Iterator<Lag_mezuak> it=datuak.iterator();
		Lag_mezuak mezua;
		Label label1, label2,label4;
		DateTime data;
		orria.setColumnView(0,15);
		orria.setColumnView(1,15);
		orria.setColumnView(2,135);
		orria.setColumnView(3, 20);
		orria.setColumnView(4, 20);
		try {
			orria.setRowView(0,500);
			orria.setRowView(5,500);
		
		} catch (RowsExceededException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		while(it.hasNext()){
			mezua=it.next();
			if(mota.equals("Jasotako Mezu Zuzena")){
				label1 = new Label(1,k,mezua.norkIdatzia,formatoa);
			}else{
				label1 = new Label(1,k,mezua.noriBidalia,formatoa);
			}
			 label2= new Label(2,k,mezua.testua,formatoa);
			
			  data= new jxl.write.DateTime(3,k,mezua.data, formatoaData);
			 label4= new Label(4,k,String.valueOf(mezua.id),formatoa);
			try {
				orria.addCell(label1);
				orria.addCell(label2);
				orria.addCell(data);
				orria.addCell(label4);
					
			} catch (RowsExceededException e) {
				
				e.printStackTrace();
			} catch (WriteException e) {
				
				e.printStackTrace();
			}
				k++;
		}
		
	}
	
	
	
	public void informazioaSortu(WritableSheet infor, ArrayList<String> exportatzeko){
		
		WritableFont letra= new WritableFont(WritableFont.TIMES,20,WritableFont.BOLD,true);
		try {
			letra.setColour(Colour.ICE_BLUE);
		} catch (WriteException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
 		WritableCellFormat tituluHandia= new WritableCellFormat(letra); 
 		infor.setColumnView(3,35);
 		infor.setColumnView(2,40);
 		try {
			infor.setRowView(2,500);
			infor.setRowView(5, 350);
			infor.setRowView(7, 350);
		} catch (RowsExceededException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
 		
 		
 		WritableFont letra2= new WritableFont(WritableFont.TIMES,16,WritableFont.BOLD,true);
 		WritableCellFormat tituluak= new WritableCellFormat(letra2); 
		
		Label label= new Label(1,2,hA.getValue("iO"),tituluHandia);
		Label label1=new Label(2,5,hA.getValue("ize")+":",tituluak);
		Label label2 = null;
		Label label3= new Label(5,5,hA.getValue("aP"),tituluak);
		Label label4=new Label(2,7,hA.getValue("eI"),tituluak);
		int i=7;
		for(String elem:exportatzeko){
			Label label5=new Label(3,i,elem);
			try {
				infor.addCell(label5);
			} catch (RowsExceededException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (WriteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			i++;
		}
		
		try {
			label2= new Label(3,5, Aplikazioa.getInstantzia().getTwitter().getScreenName());
		} catch (IllegalStateException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (TwitterException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		try {
			infor.addCell(label);
			infor.addCell(label1);
			infor.addCell(label2);
			infor.addCell(label3);
			infor.addCell(label4);
		} catch (WriteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void hasieratuDena(){
	
		
		denak.setSelected(false);
		tweetak.setSelected(false);
		mentzioak.setSelected(false);
		faboritoak.setSelected(false);
		rt.setSelected(false);
		bmz.setSelected(false);
		jmz.setSelected(false);
		artxiboaGordetzekoPatha.setText("");
		artxiboIzena.setText("");
	}
}
