package Klaseak;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JLabel;
import twitter4j.TwitterException;
import jxl.Sheet;
import jxl.Workbook;
import jxl.read.biff.BiffException;



public class BabeskopiakInportatu extends JFrame {

	private JPanel contentPane;
	private JTextField zabaltzekoPatha;
	private TweetenKontsulta kontsulta= new TweetenKontsulta();
	private MezuZuzenak_kontsultak kontsulta2= new MezuZuzenak_kontsultak();
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BabeskopiakInportatu frame = new BabeskopiakInportatu();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public BabeskopiakInportatu() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setTitle("Babes kopiak inportatu");
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		botoiakSortu();
		labelakSortu();
		textFieldSortu();
		
		
	}
	
	public void labelakSortu(){
		
		JLabel lblZeinArtxiboInportatu = new JLabel("Zein artxibo inportatu nahi duzu?");
		lblZeinArtxiboInportatu.setBounds(24, 22, 254, 15);
		contentPane.add(lblZeinArtxiboInportatu);
		
		JLabel lblHonekinLortzenDuzuna = new JLabel("Honekin lortzen duzuna da artxiboan duzuna datu basean gordetzea.");
		lblHonekinLortzenDuzuna.setBounds(24, 49, 412, 25);
		contentPane.add(lblHonekinLortzenDuzuna);
	}
	
	
	
	
	public void botoiakSortu(){
		
		JButton btnIrten = new JButton("Irten");
		btnIrten.setBounds(319, 234, 117, 25);
		contentPane.add(btnIrten);
		
		btnIrten.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				JFrame frame = Aplikazioa.getInstantzia().getMenuNagusia();
				BabeskopiakInportatu.this.dispose();
				frame.setVisible(true);
				
			}
		});
		
		JButton btnInportatu = new JButton("Inportatu");
		btnInportatu.setBounds(175, 234, 117, 25);
		contentPane.add(btnInportatu);
		
		btnInportatu.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				 BabeskopiakInportatu.this.datuakInportatu();
				
			}
		});
		
		JButton btnExaminar = new JButton("Examinar");
		btnExaminar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
				JFileChooser examinar= new JFileChooser();
				int erantzuna= examinar.showOpenDialog(BabeskopiakInportatu.this);
				examinar.setVisible(true);
				
				if(erantzuna==JFileChooser.APPROVE_OPTION){
				String patha=examinar.getSelectedFile().getAbsolutePath();
				zabaltzekoPatha.setText(patha);
				}
				
			}
		});
		btnExaminar.setBounds(24, 119, 117, 25);
		contentPane.add(btnExaminar);
	}
	
	public void textFieldSortu(){
		zabaltzekoPatha = new JTextField();
		zabaltzekoPatha.setText("/");
		zabaltzekoPatha.setBounds(175, 122, 234, 19);
		contentPane.add(zabaltzekoPatha);
		zabaltzekoPatha.setColumns(10);
	}

	
	public void datuakInportatu(){
		
		Workbook gordetzeko = null;
		try {
			gordetzeko = Workbook.getWorkbook(new File(zabaltzekoPatha.getText()));
		} catch (BiffException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		int orriKop=gordetzeko.getNumberOfSheets();
		
		String kontuarenJabea="";
		try {
			kontuarenJabea = Aplikazioa.getInstantzia().getTwitter().getScreenName();
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TwitterException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		if(gordetzeko.getSheet(0).getCell(3,5).getContents().equals(kontuarenJabea)){
			for(int kop=1;kop<=orriKop;kop++){
				
				Sheet orrialdea= gordetzeko.getSheet(kop);
				tweetakGorde(orrialdea,kontuarenJabea);
			}
		}else{
			JOptionPane.showMessageDialog(BabeskopiakInportatu.this,"Errorea! Artxibo hau ez da zure kontukoa!");
		}
	
	}
	
	public void tweetakGorde(Sheet orrialdea, String jabea){
		
		boolean hutsik=false;
		int i=6;
		
		String norena;
		String testua;
		Date data;
		long dataAldatuta;
		long id;
		
		
		while (!hutsik){
			
			if(orrialdea.getCell(1,i).getContents().equals("")){
				hutsik=true;
			}else{
			
			norena=orrialdea.getCell(1,i).getContents();
			testua=orrialdea.getCell(2,i).getContents();
			data=formatoaAldatu(orrialdea.getCell(3,i).getContents());
			dataAldatuta=data.getTime()/1000L;
			id=Long.parseLong(orrialdea.getCell(4,i).getContents());
			
				if(orrialdea.getName().equals("Jasotako Mezu Zuzenak")|| orrialdea.getName().equals("Bidalitako Mezu Zuzenak")){
					String mota;
					if (orrialdea.getName().equals("Jasotako Mezu Zuzenak")){
						mota="jasotakoa";
					}else{
						mota="bidalitakoa";
					}
					mezuakGorde(norena, testua,dataAldatuta,id,mota ,jabea);
					
				}else if(orrialdea.getName().equals("Tweeta")){
				
					kontsulta.tweetaSartuEdoAldatu(id,jabea, norena,dataAldatuta,testua);
					
				}else{ 
					kontsulta.tweetMotaSartuEdoAldatu(id,jabea, norena,dataAldatuta, testua,orrialdea.getCell(0,0).getContents());
				}
			i++;
			}
		}
		
		
	}
	public void mezuakGorde(String norena, String testua,long data, long id, String mota,String izena){
		
		if (mota.equals("jasotakoa")){
			kontsulta2.kargatuMezuak(id, izena, norena, izena, testua, data);
		}else{
		
		kontsulta2.kargatuMezuak(id, izena, izena, norena, testua, data);
		}
	}
	
	
	
	
	
	public Date formatoaAldatu(String stringData){
		
		SimpleDateFormat formatoaAldatzeko=new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
		Date data=null;
		try {
			
			data=formatoaAldatzeko.parse(stringData);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return data;
	}
}
