package Klaseak;
import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PiePlot3D;
import org.jfree.data.general.DefaultPieDataset;
import org.jfree.data.general.PieDataset;
import org.jfree.util.Rotation;

import twitter4j.Twitter;
import twitter4j.TwitterException;

import javax.swing.JButton;


public class GrafikoaGaztaia {
	
	 private static JFreeChart chart;
	 
	 
	 
	 public static JPanel grafikoaAtera(String grafikoTituloa, Date data1,Date data2){
		 PieDataset datuak = datuakLortu(data1,data2);
		 chart = createChart(datuak, grafikoTituloa);
		 ChartPanel chartPanel = new ChartPanel(chart);
		 chartPanel.setPreferredSize(new java.awt.Dimension(370,340));
		  
		 return chartPanel;
	 }
	 public static PieDataset datuakLortu(Date data1, Date data2) {
		  HizkuntzaAldaketa hA = new HizkuntzaAldaketa();
	  DefaultPieDataset datuak = new DefaultPieDataset();
	 
	  Estatistikak_kontsulta kontsulta= new Estatistikak_kontsulta();
	  Twitter twitter= Aplikazioa.getInstantzia().getTwitter();
	  int tweetKop=0;
	  int fabKop=0;
	  int mentzKop=0;
	  int rtKop=0;
	  int bmz=0;
	  int jmz=0;
	  long datams1=(data1.getTime())/1000L;
	  long datams2 = (data2.getTime())/1000L;
		try {
			tweetKop = kontsulta.kopuruaLortu(twitter.getScreenName(), "Tweeta",datams1, datams2);
			fabKop=kontsulta.kopuruaLortu(twitter.getScreenName(), "Faboritoa",datams1, datams2);
			mentzKop=kontsulta.kopuruaLortu(twitter.getScreenName(), "Mentzioa",datams1, datams2);
			rtKop=kontsulta.kopuruaLortu(twitter.getScreenName(), "RT",datams1, datams2);
			bmz= kontsulta.mezuaKopuruaLortu(twitter.getScreenName(), "bidalitakoa",datams1, datams2);
			jmz= kontsulta.mezuaKopuruaLortu(twitter.getScreenName(), "jasotakoa",datams1, datams2);
		} catch (IllegalStateException | SQLException | TwitterException e1) {
			
			e1.printStackTrace();
		}
	 
		datuak.setValue(hA.getValue("t"),tweetKop);
		datuak.setValue(hA.getValue("f"),fabKop);
		datuak.setValue(hA.getValue("m"), mentzKop);
		datuak.setValue(hA.getValue("rt"), rtKop);
		datuak.setValue(hA.getValue("imz"),bmz );
		datuak.setValue(hA.getValue("jmz"),jmz );
	  
	  return datuak;
	 
	 }
	 
	 /**
	  * Creates a chart
	  */
	 
	 public static JFreeChart createChart(PieDataset datuak, String tituloa) {
	 
	  JFreeChart chart = ChartFactory.createPieChart3D(tituloa,datuak,true,true,false);
	 
	  PiePlot3D plot = (PiePlot3D) chart.getPlot();
	  plot.setStartAngle(290);
	  plot.setDirection(Rotation.CLOCKWISE);
	  plot.setForegroundAlpha(0.5f);
	  return chart;
	 
	 }
	 
	 
	 
	  
}

