package Klaseak;

import java.awt.EventQueue;
import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.CategoryLabelPositions;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

import twitter4j.Twitter;
import twitter4j.TwitterException;





public class GrafikoakBarra  {

	
	private static JFreeChart chart ;
		 public static ChartPanel grafikoaAtera(String chartTitle,Date data1, Date data2){
			 
			  DefaultCategoryDataset datuak = datuakSortu(data1, data2);
			  chart = createChart(datuak, chartTitle);
			  ChartPanel chartPanel = new ChartPanel(chart);
			  chartPanel.setPreferredSize(new java.awt.Dimension(370,340));
			  
			  
			 return chartPanel;
		 }
		 public static  DefaultCategoryDataset datuakSortu(Date data1, Date data2) {
			 
			 HizkuntzaAldaketa hA = new HizkuntzaAldaketa();
			 DefaultCategoryDataset datuak = new DefaultCategoryDataset();
		   
			  int tweetKop=0;
			  int mentzKop=0;
			  int faboKop=0;
			  int rtKop=0;
			  int jmzKop=0;
			  int bmzKop=0;
			  int lagunKop=0;
			  int jarraitzaileKop=0;
		  
			  Twitter twitter= Aplikazioa.getInstantzia().getTwitter();
			  Estatistikak_kontsulta kontsulta= new Estatistikak_kontsulta();
			  long  datams1=(data1.getTime())/1000L;
			  long datams2=(data2.getTime())/1000L;
			  
			  try {
				 tweetKop =kontsulta.kopuruaLortu(twitter.getScreenName(), "Tweeta", datams1,datams2);
				 mentzKop = kontsulta.kopuruaLortu(twitter.getScreenName(), "Mentzioa",datams1,datams2);
				 faboKop = kontsulta.kopuruaLortu(twitter.getScreenName(), "Faboritoa", datams1,datams2);
				 rtKop = kontsulta.kopuruaLortu(twitter.getScreenName(), "RT", datams1,datams2);
				 jmzKop = kontsulta.mezuaKopuruaLortu(twitter.getScreenName(), "jasotakoa",datams1,datams2);
				 bmzKop = kontsulta.mezuaKopuruaLortu(twitter.getScreenName(), "bidalitakoa", datams1,datams2);
				 lagunKop = Lagunak.lagunKopuruaLortu();
				 jarraitzaileKop= Lagunak.jarraitzaileakLortu();
				 
			} catch (IllegalStateException | SQLException | TwitterException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			  
			  datuak.addValue(tweetKop, hA.getValue("nireT"), hA.getValue("t"));
			  datuak.addValue(mentzKop, hA.getValue("nireM"), hA.getValue("m"));
			  datuak.addValue(faboKop, hA.getValue("nireF"),hA.getValue("f"));
			  datuak.addValue(rtKop, hA.getValue("nireRT"), hA.getValue("rt"));
			  datuak.addValue(jmzKop,hA.getValue("jmz") , hA.getValue("jm"));
			  datuak.addValue(bmzKop, hA.getValue("imz"), hA.getValue("bm"));
			  datuak.addValue(lagunKop, hA.getValue("lagEs"), hA.getValue("lag"));
			  datuak.addValue(jarraitzaileKop, hA.getValue("jarEs"), hA.getValue("jar"));
			   
			   
			   
			  return datuak;
		 
		 }
		 
		 /**
		  * Creates a chart
		  */
		 
		 public static JFreeChart createChart(DefaultCategoryDataset datuak, String title) {
			 HizkuntzaAldaketa hA = new HizkuntzaAldaketa();
			  JFreeChart chart = ChartFactory.createBarChart3D(title,hA.getValue("dt") ,
					  hA.getValue("kopT"), datuak, PlotOrientation.VERTICAL, true, true, false);
			  CategoryPlot plot = (CategoryPlot) chart.getPlot();
			  CategoryAxis xAxis = (CategoryAxis) plot.getDomainAxis();
			  xAxis.setCategoryLabelPositions(CategoryLabelPositions.UP_45); // Inclinamos 45 grados las etiquetas del eje X 
			  plot.setBackgroundAlpha(0.5f);
			  return chart;
		 
		 }
		 
		 
		 
}		 
	
