package Klaseak;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTabbedPane;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.JButton;

import com.toedter.calendar.JCalendar;

import twitter4j.Twitter;
import twitter4j.TwitterException;



public class Konfigurazioa extends JFrame {

	private JPanel contentPane;
	private JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
	private JPanel panel_1 = new JPanel();
	private JPanel panel = new JPanel();
	private JPanel panel_2=new JPanel();
	private JRadioButton euskara, gaztelera, ingelera, alemaniera;
	private HizkuntzaAldaketa hA = new HizkuntzaAldaketa();
	private KonfigurazioKontsulta kontsulta= new KonfigurazioKontsulta();
	private JCalendar egutegiaNondik;
	private JCalendar egutegiaNora;
	private JCheckBox denak; 
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Konfigurazioa frame = new Konfigurazioa();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
		}
	

	public Konfigurazioa() throws SQLException {
		setTitle(hA.getValue("konf"));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 605, 424);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		
		
		hizkuntzak();
		estatistikak();
		datuPertsonalakBorratu();
				
		
	}

		
	public void hizkuntzak(){
		
		
		tabbedPane.setBounds(12, 12, 579, 371);
		contentPane.add(tabbedPane);
		
		
		tabbedPane.addTab(hA.getValue("hizk"), null, panel, null);
		panel.setLayout(null);
		
		botoiakSortuHizkuntza();
		radioButonakSortu();
		
		
		
	}
	
	public void estatistikak(){
		tabbedPane.addTab(hA.getValue("estat"), null, panel_1, null);
		botoiakSortuEstatistika();
		jLabelakSortu();
		egutegiakSortu();
		checkBoxakSortu();
		
	}
	
	public void datuPertsonalakBorratu() throws SQLException{
		
		tabbedPane.addTab(hA.getValue("dp"), null, panel_2,null);
		panel_2.setLayout(null);
		
		botoiakSortuDatuPertsonalak();
		informazioa();

	}
	
	public void informazioa(){
		
		String izena="";
		try {
			izena = Aplikazioa.getInstantzia().getTwitter().getScreenName();
		} catch (IllegalStateException | TwitterException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		JLabel lblIzena = new JLabel(hA.getValue("ize")+":  "+izena);
		lblIzena.setBounds(12, 67, 358, 15);
		panel_2.add(lblIzena);
		Tokenak tokenak = null;
		
		try {
			tokenak = kontsulta.tokenakLortu();
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		labelakSortuDatuPertsonalak(tokenak.getAccessToken(), tokenak.getAccessTokenSecret());
		
		
	}
	public void labelakSortuDatuPertsonalak(String tokena, String tokenSecret){
		JLabel lblZureTokena = new JLabel(hA.getValue("token")+":  " +tokena);
		lblZureTokena.setBounds(12, 115, 562, 15);
		panel_2.add(lblZureTokena);
		
		JLabel lblZureTokensecreta = new JLabel(hA.getValue("tokenSecret")+":  " +tokenSecret);
		lblZureTokensecreta.setBounds(12, 162, 562, 15);
		panel_2.add(lblZureTokensecreta);
	}
	public void botoiakSortuDatuPertsonalak(){
		JButton btnIrten = new JButton(hA.getValue("i"));
		btnIrten.setBounds(431, 293, 117, 25);
		panel_2.add(btnIrten);
		
		btnIrten.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				JFrame frame = Aplikazioa.getInstantzia().getMenuNagusia();
				Konfigurazioa.this.dispose();
				frame.setVisible(true);
			}
		});
		
		JButton btnBorratu = new JButton(hA.getValue("borr"));
		btnBorratu.setBounds(302, 293, 117, 25);
		panel_2.add(btnBorratu);
		
		btnBorratu.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				
				int aukera = JOptionPane.showOptionDialog(Konfigurazioa.this,  hA.getValue("boDena"), hA.getValue("k"), JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE,
					    null, new Object[] { hA.getValue("bai"),  hA.getValue("ez")},null);
				System.out.println(aukera);
				if(aukera==0){
					try {
						kontsulta.borratuDena(Aplikazioa.getInstantzia().getTwitter().getScreenName());
						JFrame frame = Aplikazioa.getInstantzia().getLogina();
						Konfigurazioa.this.dispose();
						frame.setVisible(true);
					} catch (IllegalStateException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (TwitterException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
				}
					

				
			}
		});
	}
	
	public void botoiakSortuHizkuntza(){
		
		JButton irten = new JButton(hA.getValue("i"));
		irten.setBounds(445, 296, 117, 25);
		panel.add(irten);
		
		irten.addActionListener(new ActionListener() {
						
			public void actionPerformed(ActionEvent arg0) {
				
				JFrame frame= Aplikazioa.getInstantzia().getMenuNagusia();
				Konfigurazioa.this.dispose();
				frame.setVisible(true);
			}
		});
		
		JButton ados = new JButton(hA.getValue("ok"));
		ados.setBounds(445,246,117,25);
		panel.add(ados);
		
		ados.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				
				try {
					datuakAldatu(Aplikazioa.getInstantzia().getTwitter());
				} catch (IllegalStateException | TwitterException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				JFrame frame= Aplikazioa.getInstantzia().getMenuNagusia();
				JOptionPane.showMessageDialog(Konfigurazioa.this, hA.getValue("hizkuntzaok"));
				Konfigurazioa.this.dispose();
				frame.setVisible(true);
			}
		});
		
		JButton aplikatu= new JButton(hA.getValue("aplikatu"));
		aplikatu.setBounds(445, 196, 117, 25);
		panel.add(aplikatu);
		
		aplikatu.addActionListener(new ActionListener() {
			
			
			public void actionPerformed(ActionEvent e) {
				
				try {
					datuakAldatu(Aplikazioa.getInstantzia().getTwitter());
				} catch (IllegalStateException | TwitterException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				JOptionPane.showMessageDialog(Konfigurazioa.this, hA.getValue("hizkuntzaok"));
				
			}
		});
		
	}
	
	public void radioButonakSortu(){
		
		ButtonGroup taldea = new ButtonGroup();
		
		euskara = new JRadioButton(hA.getValue("eusk"));
		euskara.setBounds(55, 70, 149, 23);
		panel.add(euskara);
		
		gaztelera = new JRadioButton(hA.getValue("gazt"));
		gaztelera.setBounds(55, 140, 149, 23);
		panel.add(gaztelera);
		
		ingelera = new JRadioButton(hA.getValue("ing"));
		ingelera.setBounds(55, 210, 149, 23);
		panel.add(ingelera);
		
		alemaniera = new JRadioButton(hA.getValue("alemn"));
		alemaniera.setBounds(55, 270, 149, 23);
		panel.add(alemaniera);
		
		taldea.add(euskara);
		taldea.add(gaztelera);
		taldea.add(ingelera);
		taldea.add(alemaniera);
	}
	
	public void botoiakSortuEstatistika(){
		panel_1.setLayout(null);
		
		JButton irten = new JButton(hA.getValue("i"));
		irten.setBounds(494, 307, 68, 25);
		panel_1.add(irten);
		
		irten.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent arg0) {
				JFrame frame =Aplikazioa.getInstantzia().getMenuNagusia();
				Konfigurazioa.this.dispose();
				frame.setVisible(true);
				
			}
		});
		
		JButton estatistikak = new JButton(hA.getValue("estIku"));
		estatistikak.setBounds(327, 307, 155, 25);
		panel_1.add(estatistikak);
		
		estatistikak.addActionListener(new ActionListener() {
			
			
			public void actionPerformed(ActionEvent e) {
				
				String izena="";
				try {
					izena = Aplikazioa.getInstantzia().getTwitter().getScreenName();
				} catch (IllegalStateException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (TwitterException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				Date data1 = null;
				Date data2;
				if (denak.isSelected()){
					SimpleDateFormat datarenFormatoa=new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
					try {
						data1= datarenFormatoa.parse("2006-01-01 00:00:00");
					} catch (ParseException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					data2=new Date();
				}else{
				
				data1 = data1Lortu();
				data2 = data2Lortu();
				}
				JFrame frame=new GrafikoOrokorra(data1,data2);
				frame.setVisible(true);
			}
		});		
	}
	
	@SuppressWarnings("deprecation")
	public Date data1Lortu(){
		
		Date data= egutegiaNondik.getDate(); 
		data.setHours(00); 
		data.setMinutes(00);
		data.setSeconds(00);	
		return data;
	}
	
	@SuppressWarnings("deprecation")
	public Date data2Lortu(){
		
		Date data = egutegiaNora.getDate();
		data.setHours(23); 
		data.setMinutes(59);
		data.setSeconds(59);
		return data;
	}
	
	public void jLabelakSortu(){
		
		JLabel lblNondik = new JLabel(hA.getValue("nn"));
		lblNondik.setBounds(12, 23, 87, 15);
		panel_1.add(lblNondik);
		
		JLabel lblNora = new JLabel(hA.getValue("nr"));
		lblNora.setBounds(281, 23, 96, 15);
		panel_1.add(lblNora);
	}
	
	public void egutegiakSortu(){
		
		egutegiaNondik = new JCalendar();
		egutegiaNondik.setBounds(10, 50, 250, 150);
		panel_1.add(egutegiaNondik);
		
		egutegiaNora = new JCalendar();
		egutegiaNora.setBounds(280, 50, 250, 150);
		panel_1.add(egutegiaNora);
		
		
	}
	
	public void checkBoxakSortu(){
		denak = new JCheckBox(hA.getValue("all"));
		denak.setBounds(8, 257, 129, 23);
		panel_1.add(denak);
	}
	
	public void datuakAldatu(Twitter twitter) throws IllegalStateException, TwitterException{
		
			String eusk="ez";
			String gazt="ez";
			String ingl="ez";
			String aleman="ez";
		
			if(euskara.isSelected()){
				
				eusk="bai";
				
			}else if (gaztelera.isSelected()){
				
				gazt="bai";
				
			}else if (ingelera.isSelected()){
				
				ingl="bai";
				
			}else{
				
				aleman="bai";
				
			}
				
			kontsulta.hizkuntzaAldatu(eusk,gazt,ingl,aleman, twitter.getScreenName());
		
	}
	
}