package Klaseak;
import java.awt.BorderLayout;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JCheckBox;

import twitter4j.TwitterException;

import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.toedter.calendar.JCalendar;

public class TweetakIkusi extends JFrame {

	private JPanel contentPane;
	private JPanel panel;
	private JCalendar egutegiNondik;
	private JCalendar egutegiNora;
	private HizkuntzaAldaketa hA= new HizkuntzaAldaketa();
	private JCheckBox mentzioak,denak,jasotakoMezuZuzenak,retweetak, idatzitakoMezuZuzenak,faboritoak, tweetak;
	private JCheckBox dataGuztiak;
	private KonfigurazioKontsulta kontsulta= new KonfigurazioKontsulta();
	
	/**
	 * Launch the application.
	 */
	

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				
					TweetakIkusi frame = new TweetakIkusi();
					frame.setVisible(true);
				
			}
		});
	}

	/**
	 * Create the frame.
	 */
	
	public TweetakIkusi() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 625, 468);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(5, 5));
		setContentPane(contentPane);
		
		
		panel = new JPanel();
		contentPane.add(panel, BorderLayout.CENTER);
		panel.setLayout(null);
		
		egutegiakSortu();
		botoiakSortu();
		jLabelakSortu();
		checkBoxakSortu();
								
	}
	
	
	public void jLabelakSortu(){
		
		JLabel lblNondik = new JLabel(hA.getValue("nn"));
		lblNondik.setBounds(8, 39, 170, 15);
		panel.add(lblNondik);
		
		JLabel lblNora = new JLabel(hA.getValue("nr"));
		lblNora.setBounds(310, 39, 186, 15);
		panel.add(lblNora);
		
		JLabel lblZerIkusiNahi = new JLabel(hA.getValue("zerIk"));
		lblZerIkusiNahi.setBounds(12, 272, 433, 15);
		panel.add(lblZerIkusiNahi);
	}
	
	public void botoiakSortu(){
		
		JButton btnBilatu = new JButton(hA.getValue("bil"));
		btnBilatu.setBounds(368, 392, 113, 25);
		panel.add(btnBilatu);
		
		btnBilatu.addActionListener(new ActionListener() {
								
			@SuppressWarnings("deprecation")
			@Override
			public void actionPerformed(ActionEvent arg0) {
				
				
				Date data1 = dataNondikLortu();
				Date data2 = dataNoraLortu();
				ArrayList<String> tweetMotak=tweetArraiaBete();
				ArrayList<String> mezuMotak=mezuArraiaBete();
				
				Bentana frame;
					try {
						frame = new Bentana(tweetMotak, mezuMotak,(data1.getTime())/1000L, (data2.getTime())/1000L);
						
						frame.setVisible(true);
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					denaHasieratu();
										
				}
			}
		);
			
		
			
		JButton btnIrten = new JButton(hA.getValue("i"));
		btnIrten.setBounds(493, 392, 112, 25);
		panel.add(btnIrten);
		
		btnIrten.addActionListener(new ActionListener(){
			
			public void actionPerformed(ActionEvent e) {
                
				
				JFrame frame=Aplikazioa.getInstantzia().getMenuNagusia();
				TweetakIkusi.this.dispose(); 
                frame.setVisible(true);
                
			
		}
		});
		
	}
	
	public Date dataNondikLortu(){
		
		Date data1 = null;
		
		if(dataGuztiak.isSelected()){
			
			
				try {
					SimpleDateFormat datarenFormatoa=new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
					try {
						data1= datarenFormatoa.parse("2006-01-01 00:00:00");
					} catch (ParseException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
				} catch (IllegalStateException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			
			
		}else{
		
			data1 = egutegiNondik.getDate();
			data1.setHours(00); 
			data1.setMinutes(00);
			data1.setSeconds(00);
		}
		return data1;
		
	}
	public Date dataNoraLortu(){
		
		Date data2=null;
		
		if(dataGuztiak.isSelected()){
			
		
				data2=new Date();
			
			
		}else{
		
			data2 = egutegiNora.getDate();
			data2.setHours(23);
			data2.setMinutes(59);
			data2.setSeconds(59);
			
		}
		return data2;
	}
	
	public ArrayList<String> tweetArraiaBete(){
		ArrayList<String> tweetMotak=new ArrayList<String>();
		if (denak.isSelected()){
			
			tweetMotak.add("Mentzioa");
			tweetMotak.add("Faboritoa");
			tweetMotak.add("Tweeta");
			tweetMotak.add("RT");
			
			
		}else{
			
		
			if (mentzioak.isSelected()){
				tweetMotak.add("Mentzioa");
			}
			if (faboritoak.isSelected()){
				tweetMotak.add("Faboritoa");
			}
			if (tweetak.isSelected()){
				tweetMotak.add("Tweeta");
			}
			if(retweetak.isSelected()){
				tweetMotak.add("RT");
			}
		}
		
		return tweetMotak;
	}
	
	public ArrayList<String> mezuArraiaBete(){
		ArrayList<String> mezuMotak =new ArrayList<String>();
		
		if(denak.isSelected()){
			mezuMotak.add("jasotakoa");
			mezuMotak.add("bidalitakoa");
			
		}else{
		
		
			if(jasotakoMezuZuzenak.isSelected()){
				mezuMotak.add("jasotakoa");
			}
			if(idatzitakoMezuZuzenak.isSelected()){
				mezuMotak.add("bidalitakoa");
			}
		}
		
		return mezuMotak;
	}

	public void checkBoxakSortu(){
		
		
		mentzioak = new JCheckBox(hA.getValue("m"));
		mentzioak.setBounds(20, 297, 147, 23);
		panel.add(mentzioak);
		
		faboritoak = new JCheckBox(hA.getValue("f"));
		faboritoak.setBounds(20, 340, 147, 23);
		panel.add(faboritoak);
		
		idatzitakoMezuZuzenak = new JCheckBox(hA.getValue("imz"));
		idatzitakoMezuZuzenak.setBounds(310, 297, 285, 23);
		panel.add(idatzitakoMezuZuzenak);
		
		tweetak = new JCheckBox(hA.getValue("t"));
		tweetak.setBounds(164, 340, 147, 23);
		panel.add(tweetak);
		
		retweetak = new JCheckBox(hA.getValue("rt"));
		retweetak.setBounds(164, 296, 147, 24);
		panel.add(retweetak);
		
		jasotakoMezuZuzenak = new JCheckBox(hA.getValue("jmz"));
		jasotakoMezuZuzenak.setBounds(310, 340, 256, 23);
		panel.add(jasotakoMezuZuzenak);
		
		denak = new JCheckBox(hA.getValue("all"));
		denak.setBounds(24, 375, 104, 23);
		panel.add(denak);
		
		dataGuztiak = new JCheckBox(hA.getValue("dataGu"));
		dataGuztiak.setBounds(18, 223, 137, 25);
		panel.add(dataGuztiak);
		
		
		denak.addActionListener(new ActionListener() {
			
			
			public void actionPerformed(ActionEvent arg0) {
				
				if (denak.isSelected()){
					
					jasotakoMezuZuzenak.setEnabled(false);
					retweetak.setEnabled(false);
					tweetak.setEnabled(false);
					idatzitakoMezuZuzenak.setEnabled(false);
					faboritoak.setEnabled(false);
					mentzioak.setEnabled(false);
								
				}else{
					
									
					jasotakoMezuZuzenak.setEnabled(true);
					retweetak.setEnabled(true);
					tweetak.setEnabled(true);
					idatzitakoMezuZuzenak.setEnabled(true);
					faboritoak.setEnabled(true);
					mentzioak.setEnabled(true);
								
				}
			}	
		});
		
	}
	
	public void denaHasieratu(){
		
		dataGuztiak.setEnabled(true);
		dataGuztiak.setSelected(false);
		tweetak.setEnabled(true);
		tweetak.setSelected(false);
		mentzioak.setEnabled(true);
		mentzioak.setSelected(false);
		faboritoak.setEnabled(true);
		faboritoak.setSelected(false);
		retweetak.setEnabled(true);
		retweetak.setSelected(false);
		jasotakoMezuZuzenak.setEnabled(true);
		jasotakoMezuZuzenak.setSelected(false);
		idatzitakoMezuZuzenak.setEnabled(true);
		idatzitakoMezuZuzenak.setSelected(false);
		denak.setSelected(false);
		
	}
	public void egutegiakSortu(){
		
		egutegiNondik = new JCalendar();
		egutegiNondik.setBounds(8, 70, 285, 140);
		panel.add(egutegiNondik);
		
		
		
		egutegiNora = new JCalendar();
		egutegiNora.setBounds(320, 70, 285, 140);
		panel.add(egutegiNora);
	}
}
